-- zadania.adb

with Ada.Real_Time;
use Ada.Real_Time;
with Ada.Synchronous_Task_Control;
use Ada.Synchronous_Task_Control;
with Ada.Numerics.Float_Random;
use Ada.Numerics.Float_Random;
with Ada.Text_IO;
use  Ada.Text_IO;
with Bufor;

package body Zadania is

  protected body Ekran is
    procedure Pisz(S : String) is
    begin
      Put_Line(S);
    end Pisz;
  end Ekran;

  task body Producent is
    Nastepny : Ada.Real_Time.Time;
    Okres : constant Ada.Real_Time.Time_Span := Ada.Real_Time.Milliseconds(1200);
    Gen : Generator;
    F   : Float;
  begin
    Nastepny := Ada.Real_Time.Clock;
    Ekran.Pisz("Zadanie producent: początek");
    loop
      delay until Nastepny;
      F := Random(Gen);
      Ekran.Pisz("* Producent >> " & F'Img);
      Bufor.Wstaw(F);
      Nastepny := Nastepny + Okres;
    end loop;
  end Producent;

  task body Konsument is
    Liczba : Float := 999.9;
  begin
    Ekran.Pisz("Zadanie konsument: początek");
    loop
      Bufor.Pobierz(Liczba);
      Ekran.Pisz("* Konsument << " & Liczba'Img);
    end loop;

  end Konsument;

end Zadania;
